package com.winhc.repal.service.impl;

import cn.hutool.core.collection.CollUtil;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.winhc.repal.entity.RepalResponsiblePerson;
import com.winhc.repal.model.vo.ResponsiblePersonNameVO;
import com.winhc.repal.repository.RepalResponsiblePersonMapper;
import com.winhc.repal.service.RepalResponsiblePersonService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @description RepalResponsiblePerson 接口实现类
 * @author Generator
 * @date 2022-04-08
 */
@Service
public class RepalResponsiblePersonServiceImpl extends ServiceImpl<RepalResponsiblePersonMapper, RepalResponsiblePerson> implements RepalResponsiblePersonService {

    @Autowired
    private RepalResponsiblePersonMapper repalResponsiblePersonMapper;

    @Override
    public Map<Long, List<String>> getResponsiblePersonNameList(List<Long> billIdList) {
        if (CollUtil.isEmpty(billIdList)) {
            return new HashMap<>();
        }
        List<ResponsiblePersonNameVO> nameList = repalResponsiblePersonMapper.getResponsiblePersonNameList(billIdList);
        if (CollUtil.isEmpty(nameList)) {
            return new HashMap<>();
        }
        return nameList.stream().collect(Collectors.groupingBy(ResponsiblePersonNameVO::getRepalBillId, Collectors.mapping(ResponsiblePersonNameVO::getUserName, Collectors.toList())));
    }
}
